/* DesktopApp.c generated by valac 0.44.11, the Vala compiler
 * generated from DesktopApp.vala, do not modify */

/*-
 * Copyright (c) 2017 Adam Bieńkowski
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gee.h>

#define APP_EDITOR_TYPE_DESKTOP_APP (app_editor_desktop_app_get_type ())
#define APP_EDITOR_DESKTOP_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp))
#define APP_EDITOR_DESKTOP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopAppClass))
#define APP_EDITOR_IS_DESKTOP_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_EDITOR_TYPE_DESKTOP_APP))
#define APP_EDITOR_IS_DESKTOP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_EDITOR_TYPE_DESKTOP_APP))
#define APP_EDITOR_DESKTOP_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopAppClass))

typedef struct _AppEditorDesktopApp AppEditorDesktopApp;
typedef struct _AppEditorDesktopAppClass AppEditorDesktopAppClass;
typedef struct _AppEditorDesktopAppPrivate AppEditorDesktopAppPrivate;

#define TYPE_APP_CATEGORY (app_category_get_type ())
typedef struct _AppCategory AppCategory;
enum  {
	APP_EDITOR_DESKTOP_APP_0_PROPERTY,
	APP_EDITOR_DESKTOP_APP_INFO_PROPERTY,
	APP_EDITOR_DESKTOP_APP_NUM_PROPERTIES
};
static GParamSpec* app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _app_category_free0(var) ((var == NULL) ? NULL : (var = (app_category_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL,
	APP_EDITOR_DESKTOP_APP_NUM_SIGNALS
};
static guint app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_NUM_SIGNALS] = {0};

struct _AppEditorDesktopApp {
	GObject parent_instance;
	AppEditorDesktopAppPrivate * priv;
};

struct _AppEditorDesktopAppClass {
	GObjectClass parent_class;
};

struct _AppCategory {
	gchar* id;
	const gchar* name;
	gchar* icon_name;
};

struct _AppEditorDesktopAppPrivate {
	gchar* display_name;
	gchar* description;
	GIcon* icon;
	gchar* commandline;
	gchar* path;
	gchar** categories;
	gint categories_length1;
	gint _categories_size_;
	AppCategory* main_category;
	GDesktopAppInfo* _info;
};

static gint AppEditorDesktopApp_private_offset;
static gpointer app_editor_desktop_app_parent_class = NULL;
static GIcon* app_editor_desktop_app_default_icon;
static GIcon* app_editor_desktop_app_default_icon = NULL;

GType app_editor_desktop_app_get_type (void) G_GNUC_CONST;
GType app_category_get_type (void) G_GNUC_CONST;
AppCategory* app_category_dup (const AppCategory* self);
void app_category_free (AppCategory* self);
void app_category_copy (const AppCategory* self,
                        AppCategory* dest);
void app_category_destroy (AppCategory* self);
#define APP_EDITOR_DESKTOP_APP_DEFAULT_LIST_SEPARATOR ';'
#define APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_PREFIX "appeditor-local-application-"
#define APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_SUFFIX ".desktop"
#define APP_EDITOR_DESKTOP_APP_USES_NOTIFICATIONS_KEY "X-GNOME-UsesNotifications"
#define APP_EDITOR_DESKTOP_APP_DEFAULT_ICON_NAME "application-x-executable"
gboolean app_editor_desktop_app_get_name_only_local (const gchar* name);
AppEditorDesktopApp* app_editor_desktop_app_new (GDesktopAppInfo* info);
AppEditorDesktopApp* app_editor_desktop_app_construct (GType object_type,
                                                       GDesktopAppInfo* info);
void app_editor_desktop_app_open_default_handler (AppEditorDesktopApp* self,
                                                  GdkScreen* screen,
                                                  GError** error);
GDesktopAppInfo* app_editor_desktop_app_get_info (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_only_local (AppEditorDesktopApp* self);
gchar* app_editor_desktop_app_get_basename (AppEditorDesktopApp* self);
gint app_editor_app_directory_scanner_get_desktop_id_count (const gchar* desktop_id);
gboolean app_editor_desktop_app_compare (AppEditorDesktopApp* self,
                                         AppEditorDesktopApp* other);
const gchar* app_editor_desktop_app_get_display_name (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_description (AppEditorDesktopApp* self);
GIcon* app_editor_desktop_app_get_icon (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_commandline (AppEditorDesktopApp* self);
const gchar* app_editor_desktop_app_get_path (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_terminal (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_display (AppEditorDesktopApp* self);
gboolean app_editor_desktop_app_get_should_show (AppEditorDesktopApp* self);
gchar** app_editor_desktop_app_get_categories (AppEditorDesktopApp* self,
                                               gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
void app_editor_desktop_app_get_main_category (AppEditorDesktopApp* self,
                                               AppCategory* result);
GeeArrayList* app_editor_desktop_app_manager_get_menu_cateogries (void);
void app_editor_desktop_app_manager_get_default_category (AppCategory* result);
static void app_editor_desktop_app_reset_values (AppEditorDesktopApp* self);
void app_editor_desktop_app_set_info (AppEditorDesktopApp* self,
                                      GDesktopAppInfo* value);
static GObject * app_editor_desktop_app_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _app_editor_desktop_app_reset_values_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void app_editor_desktop_app_finalize (GObject * obj);
static void _vala_app_editor_desktop_app_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_app_editor_desktop_app_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
app_editor_desktop_app_get_instance_private (AppEditorDesktopApp* self)
{
	return G_STRUCT_MEMBER_P (self, AppEditorDesktopApp_private_offset);
}

gboolean
app_editor_desktop_app_get_name_only_local (const gchar* name)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (name != NULL, FALSE);
	if (g_str_has_prefix (name, APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_PREFIX)) {
		_tmp0_ = g_str_has_suffix (name, APP_EDITOR_DESKTOP_APP_LOCAL_APP_NAME_SUFFIX);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

AppEditorDesktopApp*
app_editor_desktop_app_construct (GType object_type,
                                  GDesktopAppInfo* info)
{
	AppEditorDesktopApp * self = NULL;
	g_return_val_if_fail (info != NULL, NULL);
	self = (AppEditorDesktopApp*) g_object_new (object_type, "info", info, NULL);
	return self;
}

AppEditorDesktopApp*
app_editor_desktop_app_new (GDesktopAppInfo* info)
{
	return app_editor_desktop_app_construct (APP_EDITOR_TYPE_DESKTOP_APP, info);
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

void
app_editor_desktop_app_open_default_handler (AppEditorDesktopApp* self,
                                             GdkScreen* screen,
                                             GError** error)
{
	GFile* file = NULL;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_info;
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
	_tmp2_ = g_file_new_for_path (_tmp1_);
	file = _tmp2_;
	{
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = file;
		_tmp4_ = g_file_get_uri (_tmp3_);
		_tmp5_ = _tmp4_;
		gtk_show_uri (screen, _tmp5_, gtk_get_current_event_time (), &_inner_error0_);
		_g_free0 (_tmp5_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		GError* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _g_error_copy0 (_tmp6_);
		_inner_error0_ = _tmp7_;
		_g_error_free0 (e);
		goto __finally7;
	}
	__finally7:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (file);
		return;
	}
	_g_object_unref0 (file);
}

gboolean
app_editor_desktop_app_get_only_local (AppEditorDesktopApp* self)
{
	gchar* basename = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = app_editor_desktop_app_get_basename (self);
	basename = _tmp0_;
	_tmp1_ = basename;
	if (app_editor_desktop_app_get_name_only_local (_tmp1_)) {
		result = TRUE;
		_g_free0 (basename);
		return result;
	}
	_tmp2_ = basename;
	result = app_editor_app_directory_scanner_get_desktop_id_count (_tmp2_) <= 1;
	_g_free0 (basename);
	return result;
}

gboolean
app_editor_desktop_app_compare (AppEditorDesktopApp* self,
                                AppEditorDesktopApp* other)
{
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	const gchar* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = self->priv->_info;
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
	_tmp2_ = other->priv->_info;
	_tmp3_ = g_desktop_app_info_get_filename (_tmp2_);
	result = g_strcmp0 (_tmp1_, _tmp3_) == 0;
	return result;
}

const gchar*
app_editor_desktop_app_get_display_name (AppEditorDesktopApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->display_name;
	if (_tmp0_ == NULL) {
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->_info;
		_tmp2_ = g_app_info_get_display_name ((GAppInfo*) _tmp1_);
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (self->priv->display_name);
		self->priv->display_name = _tmp3_;
	}
	_tmp4_ = self->priv->display_name;
	result = _tmp4_;
	return result;
}

gchar*
app_editor_desktop_app_get_basename (AppEditorDesktopApp* self)
{
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_info;
	_tmp1_ = g_desktop_app_info_get_filename (_tmp0_);
	_tmp2_ = g_path_get_basename (_tmp1_);
	result = _tmp2_;
	return result;
}

const gchar*
app_editor_desktop_app_get_description (AppEditorDesktopApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->description;
	if (_tmp0_ == NULL) {
		const gchar* desc = NULL;
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = self->priv->_info;
		_tmp2_ = g_app_info_get_description ((GAppInfo*) _tmp1_);
		desc = _tmp2_;
		_tmp3_ = desc;
		if (_tmp3_ == NULL) {
			desc = "";
		}
		_tmp4_ = desc;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->description);
		self->priv->description = _tmp5_;
	}
	_tmp6_ = self->priv->description;
	result = _tmp6_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GIcon*
app_editor_desktop_app_get_icon (AppEditorDesktopApp* self)
{
	GIcon* _tmp0_;
	GIcon* _tmp9_;
	GIcon* _tmp10_;
	GIcon* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->icon;
	if (_tmp0_ == NULL) {
		GIcon* _icon = NULL;
		GDesktopAppInfo* _tmp1_;
		GIcon* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
		GIcon* _tmp7_;
		GIcon* _tmp8_;
		_tmp1_ = self->priv->_info;
		_tmp2_ = g_app_info_get_icon ((GAppInfo*) _tmp1_);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_icon = _tmp3_;
		_tmp4_ = _icon;
		if (_tmp4_ == NULL) {
			GIcon* _tmp5_;
			GIcon* _tmp6_;
			_tmp5_ = app_editor_desktop_app_default_icon;
			_tmp6_ = _g_object_ref0 (_tmp5_);
			_g_object_unref0 (_icon);
			_icon = _tmp6_;
		}
		_tmp7_ = _icon;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_g_object_unref0 (self->priv->icon);
		self->priv->icon = _tmp8_;
		_g_object_unref0 (_icon);
	}
	_tmp9_ = self->priv->icon;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	result = _tmp10_;
	return result;
}

const gchar*
app_editor_desktop_app_get_commandline (AppEditorDesktopApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->commandline;
	if (_tmp0_ == NULL) {
		const gchar* cmdline = NULL;
		GDesktopAppInfo* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = self->priv->_info;
		_tmp2_ = g_app_info_get_commandline ((GAppInfo*) _tmp1_);
		cmdline = _tmp2_;
		_tmp3_ = cmdline;
		if (_tmp3_ == NULL) {
			cmdline = "";
		}
		_tmp4_ = cmdline;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->commandline);
		self->priv->commandline = _tmp5_;
	}
	_tmp6_ = self->priv->commandline;
	result = _tmp6_;
	return result;
}

const gchar*
app_editor_desktop_app_get_path (AppEditorDesktopApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp7_;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->path;
	if (_tmp0_ == NULL) {
		gchar* _path = NULL;
		GDesktopAppInfo* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp1_ = self->priv->_info;
		_tmp2_ = g_desktop_app_info_get_string (_tmp1_, G_KEY_FILE_DESKTOP_KEY_PATH);
		_path = _tmp2_;
		_tmp3_ = _path;
		if (_tmp3_ == NULL) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("");
			_g_free0 (_path);
			_path = _tmp4_;
		}
		_tmp5_ = _path;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (self->priv->path);
		self->priv->path = _tmp6_;
		_g_free0 (_path);
	}
	_tmp7_ = self->priv->path;
	result = _tmp7_;
	return result;
}

gboolean
app_editor_desktop_app_get_terminal (AppEditorDesktopApp* self)
{
	GDesktopAppInfo* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_info;
	result = g_desktop_app_info_get_boolean (_tmp0_, G_KEY_FILE_DESKTOP_KEY_TERMINAL);
	return result;
}

gboolean
app_editor_desktop_app_get_display (AppEditorDesktopApp* self)
{
	GDesktopAppInfo* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_info;
	result = !g_desktop_app_info_get_nodisplay (_tmp0_);
	return result;
}

gboolean
app_editor_desktop_app_get_should_show (AppEditorDesktopApp* self)
{
	gboolean _tmp0_ = FALSE;
	GDesktopAppInfo* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_info;
	if (g_app_info_should_show ((GAppInfo*) _tmp1_)) {
		_tmp0_ = !app_editor_desktop_app_get_terminal (self);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

gchar**
app_editor_desktop_app_get_categories (AppEditorDesktopApp* self,
                                       gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->categories;
	_tmp0__length1 = self->priv->categories_length1;
	if (_tmp0_ == NULL) {
		gchar** _tmp1_;
		const gchar* unparsed = NULL;
		GDesktopAppInfo* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp1_ = g_new0 (gchar*, 0 + 1);
		self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
		self->priv->categories = _tmp1_;
		self->priv->categories_length1 = 0;
		self->priv->_categories_size_ = self->priv->categories_length1;
		_tmp2_ = self->priv->_info;
		_tmp3_ = g_desktop_app_info_get_categories (_tmp2_);
		unparsed = _tmp3_;
		_tmp4_ = unparsed;
		if (_tmp4_ != NULL) {
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar** _tmp8_;
			gchar** _tmp9_;
			_tmp5_ = unparsed;
			_tmp6_ = g_strdup_printf ("%c", APP_EDITOR_DESKTOP_APP_DEFAULT_LIST_SEPARATOR);
			_tmp7_ = _tmp6_;
			_tmp9_ = _tmp8_ = g_strsplit (_tmp5_, _tmp7_, 0);
			self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
			self->priv->categories = _tmp9_;
			self->priv->categories_length1 = _vala_array_length (_tmp8_);
			self->priv->_categories_size_ = self->priv->categories_length1;
			_g_free0 (_tmp7_);
		}
	}
	_tmp10_ = self->priv->categories;
	_tmp10__length1 = self->priv->categories_length1;
	_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup1 (_tmp10_, _tmp10__length1) : ((gpointer) _tmp10_);
	_tmp11__length1 = _tmp10__length1;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _tmp11__length1;
	if (result_length1) {
		*result_length1 = _tmp12__length1;
	}
	result = _tmp12_;
	return result;
}

static gpointer
_app_category_dup0 (gpointer self)
{
	return self ? app_category_dup (self) : NULL;
}

void
app_editor_desktop_app_get_main_category (AppEditorDesktopApp* self,
                                          AppCategory* result)
{
	AppCategory* _tmp0_;
	AppCategory* _tmp21_;
	AppCategory _tmp22_;
	AppCategory _tmp23_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_category;
	if (_tmp0_ == NULL) {
		GeeArrayList* menu_categories = NULL;
		GeeArrayList* _tmp1_;
		gboolean found = FALSE;
		gint _tmp2_ = 0;
		gchar** _tmp3_;
		AppCategory* _tmp17_;
		_tmp1_ = app_editor_desktop_app_manager_get_menu_cateogries ();
		menu_categories = _tmp1_;
		found = FALSE;
		_tmp3_ = app_editor_desktop_app_get_categories (self, &_tmp2_);
		{
			gchar** category_collection = NULL;
			gint category_collection_length1 = 0;
			gint _category_collection_size_ = 0;
			gint category_it = 0;
			category_collection = _tmp3_;
			category_collection_length1 = _tmp2_;
			for (category_it = 0; category_it < category_collection_length1; category_it = category_it + 1) {
				gchar* _tmp4_;
				gchar* category = NULL;
				_tmp4_ = g_strdup (category_collection[category_it]);
				category = _tmp4_;
				{
					{
						GeeArrayList* _menu_category_list = NULL;
						GeeArrayList* _tmp5_;
						GeeArrayList* _tmp6_;
						gint _menu_category_size = 0;
						GeeArrayList* _tmp7_;
						gint _tmp8_;
						gint _tmp9_;
						gint _menu_category_index = 0;
						_tmp5_ = menu_categories;
						_tmp6_ = _g_object_ref0 (_tmp5_);
						_menu_category_list = _tmp6_;
						_tmp7_ = _menu_category_list;
						_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
						_tmp9_ = _tmp8_;
						_menu_category_size = _tmp9_;
						_menu_category_index = -1;
						while (TRUE) {
							AppCategory* menu_category = NULL;
							GeeArrayList* _tmp10_;
							gpointer _tmp11_;
							const gchar* _tmp12_;
							AppCategory* _tmp13_;
							const gchar* _tmp14_;
							_menu_category_index = _menu_category_index + 1;
							if (!(_menu_category_index < _menu_category_size)) {
								break;
							}
							_tmp10_ = _menu_category_list;
							_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _menu_category_index);
							menu_category = (AppCategory*) _tmp11_;
							_tmp12_ = category;
							_tmp13_ = menu_category;
							_tmp14_ = (*_tmp13_).id;
							if (g_strcmp0 (_tmp12_, _tmp14_) == 0) {
								AppCategory* _tmp15_;
								AppCategory* _tmp16_;
								_tmp15_ = menu_category;
								_tmp16_ = _app_category_dup0 (_tmp15_);
								_app_category_free0 (self->priv->main_category);
								self->priv->main_category = _tmp16_;
								found = TRUE;
								_app_category_free0 (menu_category);
								break;
							}
							_app_category_free0 (menu_category);
						}
						_g_object_unref0 (_menu_category_list);
					}
					if (found) {
						_g_free0 (category);
						break;
					}
					_g_free0 (category);
				}
			}
			category_collection = (_vala_array_free (category_collection, category_collection_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp17_ = self->priv->main_category;
		if (_tmp17_ == NULL) {
			AppCategory _tmp18_ = {0};
			AppCategory _tmp19_;
			AppCategory* _tmp20_;
			app_editor_desktop_app_manager_get_default_category (&_tmp18_);
			_tmp19_ = _tmp18_;
			_tmp20_ = _app_category_dup0 (&_tmp19_);
			_app_category_free0 (self->priv->main_category);
			self->priv->main_category = _tmp20_;
			app_category_destroy (&_tmp19_);
		}
		_g_object_unref0 (menu_categories);
	}
	_tmp21_ = self->priv->main_category;
	_tmp22_ = *_tmp21_;
	app_category_copy (&_tmp22_, &_tmp23_);
	*result = _tmp23_;
	return;
}

static void
app_editor_desktop_app_reset_values (AppEditorDesktopApp* self)
{
	g_return_if_fail (self != NULL);
	_g_free0 (self->priv->display_name);
	self->priv->display_name = NULL;
	_g_free0 (self->priv->description);
	self->priv->description = NULL;
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = NULL;
	_g_free0 (self->priv->commandline);
	self->priv->commandline = NULL;
	_g_free0 (self->priv->path);
	self->priv->path = NULL;
	self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
	self->priv->categories = NULL;
	self->priv->categories_length1 = 0;
	self->priv->_categories_size_ = self->priv->categories_length1;
	_app_category_free0 (self->priv->main_category);
	self->priv->main_category = NULL;
	g_signal_emit (self, app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL], 0);
}

GDesktopAppInfo*
app_editor_desktop_app_get_info (AppEditorDesktopApp* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_info;
	result = _tmp0_;
	return result;
}

void
app_editor_desktop_app_set_info (AppEditorDesktopApp* self,
                                 GDesktopAppInfo* value)
{
	g_return_if_fail (self != NULL);
	if (app_editor_desktop_app_get_info (self) != value) {
		GDesktopAppInfo* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_info);
		self->priv->_info = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_INFO_PROPERTY]);
	}
}

static void
_app_editor_desktop_app_reset_values_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
	app_editor_desktop_app_reset_values ((AppEditorDesktopApp*) self);
}

static GObject *
app_editor_desktop_app_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppEditorDesktopApp * self;
	parent_class = G_OBJECT_CLASS (app_editor_desktop_app_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
	g_signal_connect_object ((GObject*) self, "notify::info", (GCallback) _app_editor_desktop_app_reset_values_g_object_notify, self, 0);
	return obj;
}

static void
app_editor_desktop_app_class_init (AppEditorDesktopAppClass * klass,
                                   gpointer klass_data)
{
	GThemedIcon* _tmp0_;
	app_editor_desktop_app_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AppEditorDesktopApp_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_app_editor_desktop_app_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_editor_desktop_app_set_property;
	G_OBJECT_CLASS (klass)->constructor = app_editor_desktop_app_constructor;
	G_OBJECT_CLASS (klass)->finalize = app_editor_desktop_app_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_EDITOR_DESKTOP_APP_INFO_PROPERTY, app_editor_desktop_app_properties[APP_EDITOR_DESKTOP_APP_INFO_PROPERTY] = g_param_spec_object ("info", "info", "info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	app_editor_desktop_app_signals[APP_EDITOR_DESKTOP_APP_CHANGED_SIGNAL] = g_signal_new ("changed", APP_EDITOR_TYPE_DESKTOP_APP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (APP_EDITOR_DESKTOP_APP_DEFAULT_ICON_NAME);
	_g_object_unref0 (app_editor_desktop_app_default_icon);
	app_editor_desktop_app_default_icon = (GIcon*) _tmp0_;
}

static void
app_editor_desktop_app_instance_init (AppEditorDesktopApp * self,
                                      gpointer klass)
{
	self->priv = app_editor_desktop_app_get_instance_private (self);
	self->priv->display_name = NULL;
	self->priv->description = NULL;
	self->priv->icon = NULL;
	self->priv->commandline = NULL;
	self->priv->path = NULL;
	self->priv->categories = NULL;
	self->priv->categories_length1 = 0;
	self->priv->_categories_size_ = self->priv->categories_length1;
	self->priv->main_category = NULL;
}

static void
app_editor_desktop_app_finalize (GObject * obj)
{
	AppEditorDesktopApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
	_g_free0 (self->priv->display_name);
	_g_free0 (self->priv->description);
	_g_object_unref0 (self->priv->icon);
	_g_free0 (self->priv->commandline);
	_g_free0 (self->priv->path);
	self->priv->categories = (_vala_array_free (self->priv->categories, self->priv->categories_length1, (GDestroyNotify) g_free), NULL);
	_app_category_free0 (self->priv->main_category);
	_g_object_unref0 (self->priv->_info);
	G_OBJECT_CLASS (app_editor_desktop_app_parent_class)->finalize (obj);
}

GType
app_editor_desktop_app_get_type (void)
{
	static volatile gsize app_editor_desktop_app_type_id__volatile = 0;
	if (g_once_init_enter (&app_editor_desktop_app_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppEditorDesktopAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_editor_desktop_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppEditorDesktopApp), 0, (GInstanceInitFunc) app_editor_desktop_app_instance_init, NULL };
		GType app_editor_desktop_app_type_id;
		app_editor_desktop_app_type_id = g_type_register_static (G_TYPE_OBJECT, "AppEditorDesktopApp", &g_define_type_info, 0);
		AppEditorDesktopApp_private_offset = g_type_add_instance_private (app_editor_desktop_app_type_id, sizeof (AppEditorDesktopAppPrivate));
		g_once_init_leave (&app_editor_desktop_app_type_id__volatile, app_editor_desktop_app_type_id);
	}
	return app_editor_desktop_app_type_id__volatile;
}

static void
_vala_app_editor_desktop_app_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	AppEditorDesktopApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
	switch (property_id) {
		case APP_EDITOR_DESKTOP_APP_INFO_PROPERTY:
		g_value_set_object (value, app_editor_desktop_app_get_info (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_app_editor_desktop_app_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	AppEditorDesktopApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_EDITOR_TYPE_DESKTOP_APP, AppEditorDesktopApp);
	switch (property_id) {
		case APP_EDITOR_DESKTOP_APP_INFO_PROPERTY:
		app_editor_desktop_app_set_info (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

